using System;
using System.Collections.Generic;
using System.Text;

namespace SillyText
{
    public interface IDoDebug
    {
        bool TestActive
        {
            get;
            set;
        }

        bool TriggerActive
        {
            get;
            set;
        }

        void PutMessage(string message);
        void PutMessageLine(string message);
    }

    public class ConsoleDebug : IDoDebug
    {
        private bool testActive;

        public bool TestActive
        {
            get
            {
                return testActive;
            }
            set
            {
                testActive = value;
            }
        }

        private bool triggerActive;

        public bool TriggerActive
        {
            get
            {
                return triggerActive;
            }
            set
            {
                triggerActive = value;
            }
        }

        public void PutMessage(string message)
        {
            Console.Write(message);
        }
        public void PutMessageLine(string message)
        {
            Console.WriteLine(message);
        }
    }
}
